git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Wink Saville <wink@saville.com>
To: git@vger.kernel.org
Cc: Wink Saville <wink@saville.com>,
	gister@pobox.com, sunshine@sunshineco.com,
	Johannes.Schindelin@gmx.de
Subject: [RFC PATCH v5 5/8] Add and use git_rebase__interactive__preserve_merges
Date: Fri, 23 Mar 2018 14:25:26 -0700	[thread overview]
Message-ID: <784c1d59b7d4831c57e923be3515ddf68a3a8f14.1521839546.git.wink@saville.com> (raw)
In-Reply-To: <cover.1521839546.git.wink@saville.com>
In-Reply-To: <cover.1521839546.git.wink@saville.com>

At the moment it's an exact copy of git_rebase__interactive except
the name has changed.

Signed-off-by: Wink Saville <wink@saville.com>
---
 git-rebase--interactive.sh | 108 +++++++++++++++++++++++++++++++++++++++++++++
 git-rebase.sh              |   2 +-
 2 files changed, 109 insertions(+), 1 deletion(-)

diff --git a/git-rebase--interactive.sh b/git-rebase--interactive.sh
index 2c10a7f1a..ab5513d80 100644
--- a/git-rebase--interactive.sh
+++ b/git-rebase--interactive.sh
@@ -1058,3 +1058,111 @@ git_rebase__interactive () {
 
 	complete_action
 }
+
+git_rebase__interactive__preserve_merges () {
+	initiate_action "$action"
+	ret=$?
+	if test $ret = 0; then
+		return 0
+	fi
+
+	setup_reflog_action
+	init_basic_state
+
+	if test t = "$preserve_merges"
+	then
+		if test -z "$rebase_root"
+		then
+			mkdir "$rewritten" &&
+			for c in $(git merge-base --all $orig_head $upstream)
+			do
+				echo $onto > "$rewritten"/$c ||
+					die "$(gettext "Could not init rewritten commits")"
+			done
+		else
+			mkdir "$rewritten" &&
+			echo $onto > "$rewritten"/root ||
+				die "$(gettext "Could not init rewritten commits")"
+		fi
+		# No cherry-pick because our first pass is to determine
+		# parents to rewrite and skipping dropped commits would
+		# prematurely end our probe
+		merges_option=
+	else
+		merges_option="--no-merges --cherry-pick"
+	fi
+
+	init_revisions_and_shortrevisions
+
+	if test t != "$preserve_merges"
+	then
+		git rebase--helper --make-script ${keep_empty:+--keep-empty} \
+			$revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
+		die "$(gettext "Could not generate todo list")"
+	else
+		format=$(git config --get rebase.instructionFormat)
+		# the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
+		git rev-list $merges_option --format="%m%H ${format:-%s}" \
+			--reverse --left-right --topo-order \
+			$revisions ${restrict_revision+^$restrict_revision} | \
+			sed -n "s/^>//p" |
+		while read -r sha1 rest
+		do
+
+			if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
+			then
+				comment_out="$comment_char "
+			else
+				comment_out=
+			fi
+
+			if test -z "$rebase_root"
+			then
+				preserve=t
+				for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
+				do
+					if test -f "$rewritten"/$p
+					then
+						preserve=f
+					fi
+				done
+			else
+				preserve=f
+			fi
+			if test f = "$preserve"
+			then
+				touch "$rewritten"/$sha1
+				printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
+			fi
+		done
+	fi
+
+	# Watch for commits that been dropped by --cherry-pick
+	if test t = "$preserve_merges"
+	then
+		mkdir "$dropped"
+		# Save all non-cherry-picked changes
+		git rev-list $revisions --left-right --cherry-pick | \
+			sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
+		# Now all commits and note which ones are missing in
+		# not-cherry-picks and hence being dropped
+		git rev-list $revisions |
+		while read rev
+		do
+			if test -f "$rewritten"/$rev &&
+			   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
+			then
+				# Use -f2 because if rev-list is telling us this commit is
+				# not worthwhile, we don't want to track its multiple heads,
+				# just the history of its first-parent for others that will
+				# be rebasing on top of it
+				git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
+				sha1=$(git rev-list -1 $rev)
+				sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
+				rm "$rewritten"/$rev
+			fi
+		done
+	fi
+
+	complete_action
+}
diff --git a/git-rebase.sh b/git-rebase.sh
index 6edf8c5b1..fb64ee1fe 100755
--- a/git-rebase.sh
+++ b/git-rebase.sh
@@ -197,7 +197,7 @@ run_specific_rebase () {
 		autosquash=
 	fi
 	. git-rebase--$type
-	git_rebase__$type
+	git_rebase__$type${preserve_merges:+__preserve_merges}
 	ret=$?
 	if test $ret -eq 0
 	then
-- 
2.16.2


  parent reply	other threads:[~2018-03-23 21:26 UTC|newest]

Thread overview: 42+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-03-23  4:39 [RFC PATCH v4] rebase-interactive Wink Saville
2018-03-23  4:39 ` [RFC PATCH v4] rebase-interactive: Simplify pick_on_preserving_merges Wink Saville
2018-03-23 17:10   ` Johannes Schindelin
2018-03-23  4:39 ` [RFC PATCH v4] rebase: Update invocation of rebase dot-sourced scripts Wink Saville
2018-03-23  6:26   ` Eric Sunshine
2018-03-23 21:01     ` Junio C Hamano
2018-03-23 21:18       ` Eric Sunshine
2018-03-23 17:12   ` Johannes Schindelin
2018-03-23 19:06     ` Wink Saville
2018-03-23 20:51       ` Junio C Hamano
2018-03-23 21:05         ` Wink Saville
2018-03-23 21:25 ` [RFC PATCH v5 0/8] rebase-interactive Wink Saville
2018-03-23 21:34   ` Wink Saville
2018-03-23 22:39     ` Junio C Hamano
2018-03-23 22:54       ` Wink Saville
2018-03-24  5:36         ` Wink Saville
2018-03-26 15:56           ` Junio C Hamano
2018-03-26 17:01             ` Jeff Hostetler
2018-03-26 17:57               ` Junio C Hamano
2018-03-26 18:22                 ` Jeff Hostetler
2018-03-27  5:07                   ` Junio C Hamano
2018-03-27 10:03                     ` Jeff Hostetler
2018-03-26 18:00               ` Junio C Hamano
2018-03-26 18:33                 ` Jeff Hostetler
2018-03-26 18:43                   ` Wink Saville
2018-03-26 19:37                     ` Junio C Hamano
2018-03-26 22:35                     ` Johannes Schindelin
2018-03-23 22:27   ` Junio C Hamano
2018-03-23 21:25 ` [RFC PATCH v5 1/8] rebase-interactive: simplify pick_on_preserving_merges Wink Saville
2018-03-23 21:25 ` [RFC PATCH v5 2/8] rebase: update invocation of rebase dot-sourced scripts Wink Saville
2018-03-23 21:25 ` [RFC PATCH v5 3/8] Indent function git_rebase__interactive Wink Saville
2018-03-23 22:12   ` Junio C Hamano
2018-03-23 22:52     ` Wink Saville
2018-03-23 23:06       ` Junio C Hamano
2018-03-24  0:01         ` Wink Saville
2018-03-23 21:25 ` [RFC PATCH v5 4/8] Extract functions out of git_rebase__interactive Wink Saville
2018-03-23 22:22   ` Junio C Hamano
2018-03-24  7:20   ` Eric Sunshine
2018-03-23 21:25 ` Wink Saville [this message]
2018-03-23 21:25 ` [RFC PATCH v5 6/8] Remove unused code paths from git_rebase__interactive Wink Saville
2018-03-23 21:25 ` [RFC PATCH v5 7/8] Remove unused code paths from git_rebase__interactive__preserve_merges Wink Saville
2018-03-23 21:25 ` [RFC PATCH v5 8/8] Remove merges_option and a blank line Wink Saville

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=784c1d59b7d4831c57e923be3515ddf68a3a8f14.1521839546.git.wink@saville.com \
    --to=wink@saville.com \
    --cc=Johannes.Schindelin@gmx.de \
    --cc=gister@pobox.com \
    --cc=git@vger.kernel.org \
    --cc=sunshine@sunshineco.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).